//+------------------------------------------------------------------+
//|                                                Kalman_Filter.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Red
#property indicator_width1  2

extern double             K                  = 1;
extern double             Sharpness          = 1;
extern ENUM_APPLIED_PRICE Price              = PRICE_CLOSE;
extern int                PriceSmoothing     = 1;
extern ENUM_MA_METHOD     PriceSmoothingMode = MODE_SMA;

double KF[];
double Velocity[];
double ShK;

int init()
{
 IndicatorShortName("Kalman Filter");
 IndicatorDigits(Digits);
 IndicatorBuffers(2);
 SetIndexBuffer(0,KF);
 SetIndexBuffer(1,Velocity);
 PriceSmoothing = MathMax(PriceSmoothing,1);
 ShK=MathSqrt(Sharpness*K/100.);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double Pr;
 double Distance, Error;
 pos=limit;
 while(pos>=0)
 {
  Pr=iMA(NULL, 0, PriceSmoothing, 0, PriceSmoothingMode, Price, pos);
  if (pos==Bars-2)
  {
   Velocity[pos]=0.;
   KF[pos]=Pr;
  }
  else
  {
   Distance=Pr-KF[pos+1];
   Error=KF[pos+1]+Distance*ShK;
   Velocity[pos]=Velocity[pos+1]+Distance*K/100.;
   KF[pos]=Error+Velocity[pos];
  }

  pos--;
 } 
 return(0);
}

